﻿using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using System;
using System.Collections.Generic;
using System.Text;
using Tsi1.DataLayer.Entities;

namespace Tsi1.DataLayer.EntityConfiguration
{
    public class EvaluationInscriptionConfiguration : IEntityTypeConfiguration<EvaluationInscription>
    {
        public void Configure(EntityTypeBuilder<EvaluationInscription> builder)
        {
            builder.HasKey(x => new { x.EvaluationId, x.StudentId });

            builder.Property(x => x.Grade)
                .IsRequired()
                .HasColumnType("decimal(5,2)");

            builder.HasOne(x => x.Evaluation)
                .WithMany(x => x.EvaluationInscriptions)
                .HasForeignKey(x => x.EvaluationId);

            builder.HasOne(x => x.Student)
                .WithMany(x => x.EvaluationInscriptions)
                .HasForeignKey(x => x.StudentId);
        }
    }
}
